<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOrderAdditionalField ArrayType
 * @subpackage Arrays
 */
class ArrayOfOrderAdditionalField extends AbstractStructArrayBase
{
    /**
     * The OrderAdditionalField
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OrderAdditionalField[]
     */
    public $OrderAdditionalField;
    /**
     * Constructor method for ArrayOfOrderAdditionalField
     * @uses ArrayOfOrderAdditionalField::setOrderAdditionalField()
     * @param \StructType\OrderAdditionalField[] $orderAdditionalField
     */
    public function __construct(array $orderAdditionalField = array())
    {
        $this
            ->setOrderAdditionalField($orderAdditionalField);
    }
    /**
     * Get OrderAdditionalField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OrderAdditionalField[]|null
     */
    public function getOrderAdditionalField()
    {
        return isset($this->OrderAdditionalField) ? $this->OrderAdditionalField : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOrderAdditionalField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrderAdditionalField method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrderAdditionalFieldForArrayConstraintsFromSetOrderAdditionalField(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOrderAdditionalFieldOrderAdditionalFieldItem) {
            // validation for constraint: itemType
            if (!$arrayOfOrderAdditionalFieldOrderAdditionalFieldItem instanceof \StructType\OrderAdditionalField) {
                $invalidValues[] = is_object($arrayOfOrderAdditionalFieldOrderAdditionalFieldItem) ? get_class($arrayOfOrderAdditionalFieldOrderAdditionalFieldItem) : sprintf('%s(%s)', gettype($arrayOfOrderAdditionalFieldOrderAdditionalFieldItem), var_export($arrayOfOrderAdditionalFieldOrderAdditionalFieldItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OrderAdditionalField property can only contain items of type \StructType\OrderAdditionalField, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OrderAdditionalField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OrderAdditionalField[] $orderAdditionalField
     * @return \ArrayType\ArrayOfOrderAdditionalField
     */
    public function setOrderAdditionalField(array $orderAdditionalField = array())
    {
        // validation for constraint: array
        if ('' !== ($orderAdditionalFieldArrayErrorMessage = self::validateOrderAdditionalFieldForArrayConstraintsFromSetOrderAdditionalField($orderAdditionalField))) {
            throw new \InvalidArgumentException($orderAdditionalFieldArrayErrorMessage, __LINE__);
        }
        if (is_null($orderAdditionalField) || (is_array($orderAdditionalField) && empty($orderAdditionalField))) {
            unset($this->OrderAdditionalField);
        } else {
            $this->OrderAdditionalField = $orderAdditionalField;
        }
        return $this;
    }
    /**
     * Add item to OrderAdditionalField value
     * @throws \InvalidArgumentException
     * @param \StructType\OrderAdditionalField $item
     * @return \ArrayType\ArrayOfOrderAdditionalField
     */
    public function addToOrderAdditionalField(\StructType\OrderAdditionalField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OrderAdditionalField) {
            throw new \InvalidArgumentException(sprintf('The OrderAdditionalField property can only contain items of type \StructType\OrderAdditionalField, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OrderAdditionalField[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OrderAdditionalField|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OrderAdditionalField|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OrderAdditionalField|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OrderAdditionalField|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OrderAdditionalField|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OrderAdditionalField
     */
    public function getAttributeName()
    {
        return 'OrderAdditionalField';
    }
}
